"""
 Module de test des classes et fonctions DoFn
"""
from unittest import TestCase
from testfixtures import LogCapture
from dataflow.batch.dofn.formatcolumn import FormatColumnDoFn
from utils.utils import get_schema_from_json


class FormatColumnDoFnTest(TestCase):
    """
        Classe pour tester le formatage des donnees issues de la Raw Layer 2
    """

    def setUp(self):
        self.schema_dict_ = get_schema_from_json('resources/bq/DDL/schema/sales_retail.json')
     
        self.dofn = FormatColumnDoFn()

    # tester le bon format et les bonnes valeurs
    def test_values_columns(self):
        row_test = dict(prefixe='PSH',
                        psh_brd_code='YR',
                        psh_cou_code='FR',
                        psh_ticket_id='0P01913410003:36079',
                        psh_shp_number='0004',
                        psh_typc_sales='1',
                        psh_csh_num='01',
                        psh_ticket_num='3',
                        psh_sale_date='20190514',
                        psh_sale_time='1216',
                        psh_local_tax='',
                        psh_federal_tax='',
                        psh_provincial_tax='',
                        psh_devise='EUR',
                        psh_stand_alone='N',
                        psh_mngmod_code='8',
                        psh_tva_prestation='20.00',
                        psh_voucher_dscnt_rate='0.00',
                        psh_taux_prest_ba='0.00',
                        psh_trc_vpm='37.00',
                        psh_patch_rate='',
                        psh_loc_promo='30.00',
                        psh_ctr_third_number='1800047',
                        psh_tx_com_act_kdo='2.00',
                        psh_sales_girl_code='09',
                        psh_customer_code='620518220',
                        psh_tx_voucher_fid='49.90',
                        psh_totalttcdev='24.40',
                        psh_lms_flag='N',
                        psh_csh_num_full='000401',
                        psd_brd_code='',
                        psd_cou_code='',
                        psd_psh_ticket_id='',
                        psd_line_nb='',
                        psd_typc_sales='',
                        psd_customer_code='',
                        psd_pro_code='',
                        psd_offer_code='',
                        psd_suboffer_code='',
                        psd_vat_value='',
                        psd_discount_type='',
                        psd_etrc='',
                        psd_product_discount='',
                        psd_local_promo='',
                        psd_sat_code='',
                        psd_federal_tax='',
                        psd_provincial_tax='',
                        psd_local_tax='',
                        psd_qty='',
                        psd_cat_price='',
                        psd_cat_price_tf='',
                        psd_proposed_price='',
                        psd_proposed_price_tf='',
                        psd_sale_price='',
                        psd_sale_price_tf='',
                        psd_sale_netprice='',
                        psd_sale_netprice_tf='',
                        psd_gross_sales_turnover='',
                        psd_exclusion_ca='',
                        psd_compo_code='',
                        psd_sbs_code='',
                        psd_sbs_purch_flag='',
                        psd_ticket_end_use='',
                        psd_line_yr_discount='',
                        psd_line_fr_discount='',
                        psd_eot_yr_discount='',
                        psd_eot_fr_discount='',
                        psd_line_gross_voucher_amt='',
                        psd_line_gross_voucher_amt_tf='',
                        psd_line_net_voucher_amt='',
                        psd_line_net_voucher_amt_tf='',
                        psd_eot_gross_voucher_amt='',
                        psd_eot_gross_voucher_amt_tf='',
                        psd_eot_net_voucher_amt='',
                        psd_eot_net_voucher_amt_tf='',
                        psd_partner_commission='',
                        psd_recargo_rate='',
                        psd_sof_fidelity_flag='',
                        psd_sof_yr_care_amount='',
                        psd_yr_care_discount='',
                        psd_pvc_ttc='',
                        psd_soc_amount='',
                        psd_sof_sale_gift_part='',
                        psd_mvt_type='',
                        psd_mvt_code='',
                        psd_sales_girl_code='',
                        psd_cp_code='',
                        psd_key_code='',
                        psd_cat_code='',
                        psd_sbs_code_prog='',
                        psd_return_control_flag='',
                        psd_return_motif='',
                        psd_psh_ticket_id_orig='',
                        psd_line_yr_discount_tf='',
                        psd_line_fr_discount_tf='',
                        psd_eot_yr_discount_tf='',
                        psd_eot_fr_discount_tf='',
                        psd_fid_line_yr_discount='',
                        psd_fid_mt_avoir_ht='',
                        psd_fid_mt_avoir_tva='',
                        psd_fid_mt_avoir_ttc='',
                        psp_brd_code='',
                        psp_cou_code='',
                        psp_psh_ticket_id='',
                        psp_line_nb='',
                        psp_paie_type_code='',
                        psp_payment_amt='',
                        psp_paie_mode_code='',
                        psp_devise='',
                        pdd_brd_code='',
                        pdd_cou_code='',
                        pdd_psh_ticket_id='',
                        pdd_line_nb='',
                        pdd_discount_nb='',
                        pdd_discount_origine='',
                        pdd_discount_type='',
                        pdd_offer_code='',
                        pdd_suboffer_code='',
                        pdd_key_code='',
                        pdd_discount_rate='',
                        pdd_discount_value='',
                        pdd_discount_base='',
                        pdd_discount_amt='',
                        pdd_cp_code='',
                        pdd_discount_level='',
                        pdd_cpr_effect_start_date='',
                        pdd_cpr_effect_end_date='',
                        pdd_cpr_ambassadeur_flag='',
                        pdd_sof_fid_flag='',
                        pdd_usedavantage='',
                        ppd_brd_code='',
                        ppd_cou_code='',
                        ppd_psh_ticket_id='',
                        ppd_psd_line_nb='',
                        ppd_line_nb='',
                        ppd_typc_sale='',
                        ppd_type_detail_point='',
                        ppd_nb_points='',
                        ppd_offer_code='',
                        ppd_suboffer_code='',
                        ppd_billable='',
                        ppd_point_cost='',
                        ppd_billing_point_cost='',
                        ppd_valunit_pts='',
                        ppd_cp_code='',
                        ppd_cat_code='',
                        psb_brd_code='',
                        psb_cou_code='',
                        psb_psh_ticket_id='',
                        psb_line_nb='',
                        psb_sbs_code_prog='',
                        psb_customer_code='',
                        psb_refprog='',
                        psb_identabo='',
                        psb_datevalidite='',
                        psb_datevalidesupp='',
                        psb_mntabottc='',
                        psb_mntconso='',
                        psb_mntrembourse='',
                        psb_mntrestant='',
                        psb_statut='',
                        pba_brd_code='',
                        pba_cou_code='',
                        pba_psh_ticket_id='',
                        pba_line_nb='',
                        pba_gift_card_serial_num='',
                        pba_flag_activation_conso='',
                        pba_det_modpmt='',
                        pba_qty_sold='',
                        pba_val_faciale='',
                        pba_invoiced_voucher='',
                        pba_mt_presta='',
                        pba_mt_com_act_kdo_ht='',
                        pba_mt_com_act_kdo_ttc='',
                        pba_mt_com_act_kdo_tva='',
                        pss_brd_code='',
                        pss_cou_code='',
                        pss_psh_ticket_id='',
                        pss_line_nb='',
                        pss_typc_sale='',
                        pss_compo_code='',
                        pss_qty='',
                        psc_brd_code='',
                        psc_cou_code='',
                        psc_psh_ticket_id='',
                        psc_csid='',
                        psc_journaissance='',
                        psc_moisnaissance='',
                        psc_anneenaissance='',
                        psc_segment='',
                        psc_typecliente='',
                        version_number='22',
                        source_file_name='FID_LYR_LYR_YRFR_R_VTE_20190515154804.txt',
                        processing_time='2019-05-13 15:31:20.955000'
                          )

        parsed_line = self.dofn.process(row_test, self.schema_dict_).next()

        self.assertEqual(parsed_line['prefixe'], 'PSH')
        self.assertEqual(parsed_line['psh_brd_code'], 'YR')
        self.assertEqual(parsed_line['psh_cou_code'], 'FR')
        self.assertEqual(parsed_line['psh_ticket_id'], '0P01913410003:36079')
        self.assertEqual(parsed_line['psh_shp_number'], '0004')
        self.assertEqual(parsed_line['psh_typc_sales'], '1')
        self.assertEqual(parsed_line['psh_csh_num'], '01')
        self.assertEqual(parsed_line['psh_ticket_num'], 3)
        self.assertEqual(parsed_line['psh_sale_date'], '2019-05-14')
        self.assertEqual(parsed_line['psh_sale_time'], '1216')
        self.assertEqual(parsed_line['psh_devise'], 'EUR')
        self.assertEqual(parsed_line['psh_stand_alone'], 'N')
        self.assertEqual(parsed_line['psh_mngmod_code'], '8')
        self.assertEqual(parsed_line['psh_tva_prestation'], 20.00)
        self.assertEqual(parsed_line['psh_voucher_dscnt_rate'], 0.00)
        self.assertEqual(parsed_line['psh_taux_prest_ba'], 0.00)
        self.assertEqual(parsed_line['psh_trc_vpm'], 37.00)
        self.assertEqual(parsed_line['psh_loc_promo'], 30.00)
        self.assertEqual(parsed_line['psh_ctr_third_number'], '1800047')
        self.assertEqual(parsed_line['psh_tx_com_act_kdo'], 2.00)
        self.assertEqual(parsed_line['psh_sales_girl_code'], '09')
        self.assertEqual(parsed_line['psh_customer_code'], '620518220')
        self.assertEqual(parsed_line['psh_tx_voucher_fid'], 49.90)
        self.assertEqual(parsed_line['psh_totalttcdev'], 24.40)
        self.assertEqual(parsed_line['psh_lms_flag'], 'N')
        self.assertEqual(parsed_line['psh_csh_num_full'], '000401')


    # Tester si une valeur est vide

    def test_empty_values(self):
        """

        :return:
        """
        row_test = dict(prefixe='PSH',
                        psh_brd_code='YR',
                        psh_cou_code='FR',
                        psh_ticket_id='0P01913410003:36079',
                        psh_shp_number='0004',
                        psh_typc_sales='1',
                        psh_csh_num='01',
                        psh_ticket_num='3',
                        psh_sale_date='20190514',
                        psh_sale_time='1216',
                        psh_local_tax='',
                        psh_federal_tax='',
                        psh_provincial_tax='',
                        psh_devise='EUR',
                        psh_stand_alone='N',
                        psh_mngmod_code='8',
                        psh_tva_prestation='20.00',
                        psh_voucher_dscnt_rate='0.00',
                        psh_taux_prest_ba='0.00',
                        psh_trc_vpm='37.00',
                        psh_patch_rate='',
                        psh_loc_promo='30.00',
                        psh_ctr_third_number='1800047',
                        psh_tx_com_act_kdo='2.00',
                        psh_sales_girl_code='09',
                        psh_customer_code='620518220',
                        psh_tx_voucher_fid='49.90',
                        psh_totalttcdev='24.40',
                        psh_lms_flag='N',
                        psh_csh_num_full='000401',
                        psd_brd_code='',
                        psd_cou_code='',
                        psd_psh_ticket_id='',
                        psd_line_nb='',
                        psd_typc_sales='',
                        psd_customer_code='',
                        psd_pro_code='',
                        psd_offer_code='',
                        psd_suboffer_code='',
                        psd_vat_value='',
                        psd_discount_type='',
                        psd_etrc='',
                        psd_product_discount='',
                        psd_local_promo='',
                        psd_sat_code='',
                        psd_federal_tax='',
                        psd_provincial_tax='',
                        psd_local_tax='',
                        psd_qty='',
                        psd_cat_price='',
                        psd_cat_price_tf='',
                        psd_proposed_price='',
                        psd_proposed_price_tf='',
                        psd_sale_price='',
                        psd_sale_price_tf='',
                        psd_sale_netprice='',
                        psd_sale_netprice_tf='',
                        psd_gross_sales_turnover='',
                        psd_exclusion_ca='',
                        psd_compo_code='',
                        psd_sbs_code='',
                        psd_sbs_purch_flag='',
                        psd_ticket_end_use='',
                        psd_line_yr_discount='',
                        psd_line_fr_discount='',
                        psd_eot_yr_discount='',
                        psd_eot_fr_discount='',
                        psd_line_gross_voucher_amt='',
                        psd_line_gross_voucher_amt_tf='',
                        psd_line_net_voucher_amt='',
                        psd_line_net_voucher_amt_tf='',
                        psd_eot_gross_voucher_amt='',
                        psd_eot_gross_voucher_amt_tf='',
                        psd_eot_net_voucher_amt='',
                        psd_eot_net_voucher_amt_tf='',
                        psd_partner_commission='',
                        psd_recargo_rate='',
                        psd_sof_fidelity_flag='',
                        psd_sof_yr_care_amount='',
                        psd_yr_care_discount='',
                        psd_pvc_ttc='',
                        psd_soc_amount='',
                        psd_sof_sale_gift_part='',
                        psd_mvt_type='',
                        psd_mvt_code='',
                        psd_sales_girl_code='',
                        psd_cp_code='',
                        psd_key_code='',
                        psd_cat_code='',
                        psd_sbs_code_prog='',
                        psd_return_control_flag='',
                        psd_return_motif='',
                        psd_psh_ticket_id_orig='',
                        psd_line_yr_discount_tf='',
                        psd_line_fr_discount_tf='',
                        psd_eot_yr_discount_tf='',
                        psd_eot_fr_discount_tf='',
                        psd_fid_line_yr_discount='',
                        psd_fid_mt_avoir_ht='',
                        psd_fid_mt_avoir_tva='',
                        psd_fid_mt_avoir_ttc='',
                        psp_brd_code='',
                        psp_cou_code='',
                        psp_psh_ticket_id='',
                        psp_line_nb='',
                        psp_paie_type_code='',
                        psp_payment_amt='',
                        psp_paie_mode_code='',
                        psp_devise='',
                        pdd_brd_code='',
                        pdd_cou_code='',
                        pdd_psh_ticket_id='',
                        pdd_line_nb='',
                        pdd_discount_nb='',
                        pdd_discount_origine='',
                        pdd_discount_type='',
                        pdd_offer_code='',
                        pdd_suboffer_code='',
                        pdd_key_code='',
                        pdd_discount_rate='',
                        pdd_discount_value='',
                        pdd_discount_base='',
                        pdd_discount_amt='',
                        pdd_cp_code='',
                        pdd_discount_level='',
                        pdd_cpr_effect_start_date='',
                        pdd_cpr_effect_end_date='',
                        pdd_cpr_ambassadeur_flag='',
                        pdd_sof_fid_flag='',
                        pdd_usedavantage='',
                        ppd_brd_code='',
                        ppd_cou_code='',
                        ppd_psh_ticket_id='',
                        ppd_psd_line_nb='',
                        ppd_line_nb='',
                        ppd_typc_sale='',
                        ppd_type_detail_point='',
                        ppd_nb_points='',
                        ppd_offer_code='',
                        ppd_suboffer_code='',
                        ppd_billable='',
                        ppd_point_cost='',
                        ppd_billing_point_cost='',
                        ppd_valunit_pts='',
                        ppd_cp_code='',
                        ppd_cat_code='',
                        psb_brd_code='',
                        psb_cou_code='',
                        psb_psh_ticket_id='',
                        psb_line_nb='',
                        psb_sbs_code_prog='',
                        psb_customer_code='',
                        psb_refprog='',
                        psb_identabo='',
                        psb_datevalidite='',
                        psb_datevalidesupp='',
                        psb_mntabottc='',
                        psb_mntconso='',
                        psb_mntrembourse='',
                        psb_mntrestant='',
                        psb_statut='',
                        pba_brd_code='',
                        pba_cou_code='',
                        pba_psh_ticket_id='',
                        pba_line_nb='',
                        pba_gift_card_serial_num='',
                        pba_flag_activation_conso='',
                        pba_det_modpmt='',
                        pba_qty_sold='',
                        pba_val_faciale='',
                        pba_invoiced_voucher='',
                        pba_mt_presta='',
                        pba_mt_com_act_kdo_ht='',
                        pba_mt_com_act_kdo_ttc='',
                        pba_mt_com_act_kdo_tva='',
                        pss_brd_code='',
                        pss_cou_code='',
                        pss_psh_ticket_id='',
                        pss_line_nb='',
                        pss_typc_sale='',
                        pss_compo_code='',
                        pss_qty='',
                        psc_brd_code='',
                        psc_cou_code='',
                        psc_psh_ticket_id='',
                        psc_csid='',
                        psc_journaissance='',
                        psc_moisnaissance='',
                        psc_anneenaissance='',
                        psc_segment='',
                        psc_typecliente='',
                        version_number='22',
                        source_file_name='FID_LYR_LYR_YRFR_R_VTE_20190515154804.txt',
                        processing_time='2019-05-13 15:31:20.955000')
        row_test = self.dofn.process(row_test, self.schema_dict_)

        for row in row_test:
            self.assertFalse('pdd_cpr_effect_end_date' in row)
            self.assertFalse('psc_anneenaissance' in row)
            self.assertFalse('psh_local_tax' in row)



    def test_format_columns(self):
        """
            on teste un enregistrement correct :
            toutes les zones doivent avoir le format (string, int, float ... attendu)
        :return:
        """
        row_test = dict(prefixe='PSH',
                        psh_brd_code='YR',
                        psh_cou_code='FR',
                        psh_ticket_id='0P01913410003:36079',
                        psh_shp_number='0004',
                        psh_typc_sales='1',
                        psh_csh_num='01',
                        psh_ticket_num='3',
                        psh_sale_date='20190514',
                        psh_sale_time='1216',
                        psh_local_tax='',
                        psh_federal_tax='',
                        psh_provincial_tax='',
                        psh_devise='EUR',
                        psh_stand_alone='N',
                        psh_mngmod_code='8',
                        psh_tva_prestation='20.00',
                        psh_voucher_dscnt_rate='0.00',
                        psh_taux_prest_ba='0.00',
                        psh_trc_vpm='37.00',
                        psh_patch_rate='',
                        psh_loc_promo='30.00',
                        psh_ctr_third_number='1800047',
                        psh_tx_com_act_kdo='2.00',
                        psh_sales_girl_code='09',
                        psh_customer_code='620518220',
                        psh_tx_voucher_fid='49.90',
                        psh_totalttcdev='24.40',
                        psh_lms_flag='N',
                        psh_csh_num_full='000401',
                        psd_brd_code='',
                        psd_cou_code='',
                        psd_psh_ticket_id='',
                        psd_line_nb='',
                        psd_typc_sales='',
                        psd_customer_code='',
                        psd_pro_code='',
                        psd_offer_code='',
                        psd_suboffer_code='',
                        psd_vat_value='',
                        psd_discount_type='',
                        psd_etrc='',
                        psd_product_discount='',
                        psd_local_promo='',
                        psd_sat_code='',
                        psd_federal_tax='',
                        psd_provincial_tax='',
                        psd_local_tax='',
                        psd_qty='',
                        psd_cat_price='',
                        psd_cat_price_tf='',
                        psd_proposed_price='',
                        psd_proposed_price_tf='',
                        psd_sale_price='',
                        psd_sale_price_tf='',
                        psd_sale_netprice='',
                        psd_sale_netprice_tf='',
                        psd_gross_sales_turnover='',
                        psd_exclusion_ca='',
                        psd_compo_code='',
                        psd_sbs_code='',
                        psd_sbs_purch_flag='',
                        psd_ticket_end_use='',
                        psd_line_yr_discount='',
                        psd_line_fr_discount='',
                        psd_eot_yr_discount='',
                        psd_eot_fr_discount='',
                        psd_line_gross_voucher_amt='',
                        psd_line_gross_voucher_amt_tf='',
                        psd_line_net_voucher_amt='',
                        psd_line_net_voucher_amt_tf='',
                        psd_eot_gross_voucher_amt='',
                        psd_eot_gross_voucher_amt_tf='',
                        psd_eot_net_voucher_amt='',
                        psd_eot_net_voucher_amt_tf='',
                        psd_partner_commission='',
                        psd_recargo_rate='',
                        psd_sof_fidelity_flag='',
                        psd_sof_yr_care_amount='',
                        psd_yr_care_discount='',
                        psd_pvc_ttc='',
                        psd_soc_amount='',
                        psd_sof_sale_gift_part='',
                        psd_mvt_type='',
                        psd_mvt_code='',
                        psd_sales_girl_code='',
                        psd_cp_code='',
                        psd_key_code='',
                        psd_cat_code='',
                        psd_sbs_code_prog='',
                        psd_return_control_flag='',
                        psd_return_motif='',
                        psd_psh_ticket_id_orig='',
                        psd_line_yr_discount_tf='',
                        psd_line_fr_discount_tf='',
                        psd_eot_yr_discount_tf='',
                        psd_eot_fr_discount_tf='',
                        psd_fid_line_yr_discount='',
                        psd_fid_mt_avoir_ht='',
                        psd_fid_mt_avoir_tva='',
                        psd_fid_mt_avoir_ttc='',
                        psp_brd_code='',
                        psp_cou_code='',
                        psp_psh_ticket_id='',
                        psp_line_nb='',
                        psp_paie_type_code='',
                        psp_payment_amt='',
                        psp_paie_mode_code='',
                        psp_devise='',
                        pdd_brd_code='',
                        pdd_cou_code='',
                        pdd_psh_ticket_id='',
                        pdd_line_nb='',
                        pdd_discount_nb='',
                        pdd_discount_origine='',
                        pdd_discount_type='',
                        pdd_offer_code='',
                        pdd_suboffer_code='',
                        pdd_key_code='',
                        pdd_discount_rate='',
                        pdd_discount_value='',
                        pdd_discount_base='',
                        pdd_discount_amt='',
                        pdd_cp_code='',
                        pdd_discount_level='',
                        pdd_cpr_effect_start_date='',
                        pdd_cpr_effect_end_date='',
                        pdd_cpr_ambassadeur_flag='',
                        pdd_sof_fid_flag='',
                        pdd_usedavantage='',
                        ppd_brd_code='',
                        ppd_cou_code='',
                        ppd_psh_ticket_id='',
                        ppd_psd_line_nb='',
                        ppd_line_nb='',
                        ppd_typc_sale='',
                        ppd_type_detail_point='',
                        ppd_nb_points='',
                        ppd_offer_code='',
                        ppd_suboffer_code='',
                        ppd_billable='',
                        ppd_point_cost='',
                        ppd_billing_point_cost='',
                        ppd_valunit_pts='',
                        ppd_cp_code='',
                        ppd_cat_code='',
                        psb_brd_code='',
                        psb_cou_code='',
                        psb_psh_ticket_id='',
                        psb_line_nb='',
                        psb_sbs_code_prog='',
                        psb_customer_code='',
                        psb_refprog='',
                        psb_identabo='',
                        psb_datevalidite='',
                        psb_datevalidesupp='',
                        psb_mntabottc='',
                        psb_mntconso='',
                        psb_mntrembourse='',
                        psb_mntrestant='',
                        psb_statut='',
                        pba_brd_code='',
                        pba_cou_code='',
                        pba_psh_ticket_id='',
                        pba_line_nb='',
                        pba_gift_card_serial_num='',
                        pba_flag_activation_conso='',
                        pba_det_modpmt='',
                        pba_qty_sold='',
                        pba_val_faciale='',
                        pba_invoiced_voucher='',
                        pba_mt_presta='',
                        pba_mt_com_act_kdo_ht='',
                        pba_mt_com_act_kdo_ttc='',
                        pba_mt_com_act_kdo_tva='',
                        pss_brd_code='',
                        pss_cou_code='',
                        pss_psh_ticket_id='',
                        pss_line_nb='',
                        pss_typc_sale='',
                        pss_compo_code='',
                        pss_qty='',
                        psc_brd_code='',
                        psc_cou_code='',
                        psc_psh_ticket_id='',
                        psc_csid='',
                        psc_journaissance='',
                        psc_moisnaissance='',
                        psc_anneenaissance='',
                        psc_segment='',
                        psc_typecliente='',
                        version_number='22',
                        source_file_name='FID_LYR_LYR_YRFR_R_VTE_20190515154804.txt',
                        processing_time='2019-05-13 15:31:20.955000')

        rows_generator = self.dofn.process(row_test, self.schema_dict_)

        row = rows_generator.next()
        # Tester type conforme
        self.assertIsInstance(row['prefixe'], str)
        self.assertIsInstance(row['psh_brd_code'], str)
        self.assertIsInstance(row['psh_cou_code'], str)
        self.assertIsInstance(row['psh_ticket_id'], str)
        self.assertIsInstance(row['psh_shp_number'], str)
        self.assertIsInstance(row['psh_typc_sales'], str)
        self.assertIsInstance(row['psh_csh_num'], str)
        self.assertIsInstance(row['psh_ticket_num'], int)
        self.assertIsInstance(row['psh_sale_date'], str)
        self.assertIsInstance(row['psh_sale_time'], str)
        self.assertIsInstance(row['psh_devise'], str)
        self.assertIsInstance(row['psh_stand_alone'], str)
        self.assertIsInstance(row['psh_mngmod_code'], str)
        self.assertIsInstance(row['psh_tva_prestation'], float)
        self.assertIsInstance(row['psh_voucher_dscnt_rate'], float)
        self.assertIsInstance(row['psh_taux_prest_ba'], float)
        self.assertIsInstance(row['psh_trc_vpm'], float)
        self.assertIsInstance(row['psh_loc_promo'], float)
        self.assertIsInstance(row['psh_ctr_third_number'], str)
        self.assertIsInstance(row['psh_tx_com_act_kdo'], float)
        self.assertIsInstance(row['psh_sales_girl_code'], str)
        self.assertIsInstance(row['psh_customer_code'], str)
        self.assertIsInstance(row['psh_tx_voucher_fid'], float)
        self.assertIsInstance(row['psh_totalttcdev'], float)
        self.assertIsInstance(row['psh_lms_flag'], str)
        self.assertIsInstance(row['psh_csh_num_full'], str)
        self.assertIsInstance(row['source_file_name'], str)




    def test_format_columns_parse_exception(self):
        """
            test d'un enregistrement qui ne passe pas
            (psh_tva_prestation='B' alors que cette zone est float et
            psh_voucher_dscnt_rate='A' alors que cette zone est float )
        :return:
        """
        row_test = dict(prefixe='PSH',
                        psh_brd_code='YR',
                        psh_cou_code='FR',
                        psh_ticket_id='0P01913410003:36079',
                        psh_shp_number='0004',
                        psh_typc_sales='1',
                        psh_csh_num='01',
                        psh_ticket_num='3',
                        psh_sale_date='20190514',
                        psh_sale_time='1216',
                        psh_local_tax='',
                        psh_federal_tax='',
                        psh_provincial_tax='',
                        psh_devise='EUR',
                        psh_stand_alone='N',
                        psh_mngmod_code='8',
                        psh_tva_prestation='B',
                        psh_voucher_dscnt_rate='A',
                        psh_taux_prest_ba='0.00',
                        psh_trc_vpm='37.00',
                        psh_patch_rate='',
                        psh_loc_promo='30.00',
                        psh_ctr_third_number='1800047',
                        psh_tx_com_act_kdo='2.00',
                        psh_sales_girl_code='09',
                        psh_customer_code='620518220',
                        psh_tx_voucher_fid='49.90',
                        psh_totalttcdev='24.40',
                        psh_lms_flag='N',
                        psh_csh_num_full='000401',
                        psd_brd_code='',
                        psd_cou_code='',
                        psd_psh_ticket_id='',
                        psd_line_nb='',
                        psd_typc_sales='',
                        psd_customer_code='',
                        psd_pro_code='',
                        psd_offer_code='',
                        psd_suboffer_code='',
                        psd_vat_value='',
                        psd_discount_type='',
                        psd_etrc='',
                        psd_product_discount='',
                        psd_local_promo='',
                        psd_sat_code='',
                        psd_federal_tax='',
                        psd_provincial_tax='',
                        psd_local_tax='',
                        psd_qty='',
                        psd_cat_price='',
                        psd_cat_price_tf='',
                        psd_proposed_price='',
                        psd_proposed_price_tf='',
                        psd_sale_price='',
                        psd_sale_price_tf='',
                        psd_sale_netprice='',
                        psd_sale_netprice_tf='',
                        psd_gross_sales_turnover='',
                        psd_exclusion_ca='',
                        psd_compo_code='',
                        psd_sbs_code='',
                        psd_sbs_purch_flag='',
                        psd_ticket_end_use='',
                        psd_line_yr_discount='',
                        psd_line_fr_discount='',
                        psd_eot_yr_discount='',
                        psd_eot_fr_discount='',
                        psd_line_gross_voucher_amt='',
                        psd_line_gross_voucher_amt_tf='',
                        psd_line_net_voucher_amt='',
                        psd_line_net_voucher_amt_tf='',
                        psd_eot_gross_voucher_amt='',
                        psd_eot_gross_voucher_amt_tf='',
                        psd_eot_net_voucher_amt='',
                        psd_eot_net_voucher_amt_tf='',
                        psd_partner_commission='',
                        psd_recargo_rate='',
                        psd_sof_fidelity_flag='',
                        psd_sof_yr_care_amount='',
                        psd_yr_care_discount='',
                        psd_pvc_ttc='',
                        psd_soc_amount='',
                        psd_sof_sale_gift_part='',
                        psd_mvt_type='',
                        psd_mvt_code='',
                        psd_sales_girl_code='',
                        psd_cp_code='',
                        psd_key_code='',
                        psd_cat_code='',
                        psd_sbs_code_prog='',
                        psd_return_control_flag='',
                        psd_return_motif='',
                        psd_psh_ticket_id_orig='',
                        psd_line_yr_discount_tf='',
                        psd_line_fr_discount_tf='',
                        psd_eot_yr_discount_tf='',
                        psd_eot_fr_discount_tf='',
                        psd_fid_line_yr_discount='',
                        psd_fid_mt_avoir_ht='',
                        psd_fid_mt_avoir_tva='',
                        psd_fid_mt_avoir_ttc='',
                        psp_brd_code='',
                        psp_cou_code='',
                        psp_psh_ticket_id='',
                        psp_line_nb='',
                        psp_paie_type_code='',
                        psp_payment_amt='',
                        psp_paie_mode_code='',
                        psp_devise='',
                        pdd_brd_code='',
                        pdd_cou_code='',
                        pdd_psh_ticket_id='',
                        pdd_line_nb='',
                        pdd_discount_nb='',
                        pdd_discount_origine='',
                        pdd_discount_type='',
                        pdd_offer_code='',
                        pdd_suboffer_code='',
                        pdd_key_code='',
                        pdd_discount_rate='',
                        pdd_discount_value='',
                        pdd_discount_base='',
                        pdd_discount_amt='',
                        pdd_cp_code='',
                        pdd_discount_level='',
                        pdd_cpr_effect_start_date='',
                        pdd_cpr_effect_end_date='',
                        pdd_cpr_ambassadeur_flag='',
                        pdd_sof_fid_flag='',
                        pdd_usedavantage='',
                        ppd_brd_code='',
                        ppd_cou_code='',
                        ppd_psh_ticket_id='',
                        ppd_psd_line_nb='',
                        ppd_line_nb='',
                        ppd_typc_sale='',
                        ppd_type_detail_point='',
                        ppd_nb_points='',
                        ppd_offer_code='',
                        ppd_suboffer_code='',
                        ppd_billable='',
                        ppd_point_cost='',
                        ppd_billing_point_cost='',
                        ppd_valunit_pts='',
                        ppd_cp_code='',
                        ppd_cat_code='',
                        psb_brd_code='',
                        psb_cou_code='',
                        psb_psh_ticket_id='',
                        psb_line_nb='',
                        psb_sbs_code_prog='',
                        psb_customer_code='',
                        psb_refprog='',
                        psb_identabo='',
                        psb_datevalidite='',
                        psb_datevalidesupp='',
                        psb_mntabottc='',
                        psb_mntconso='',
                        psb_mntrembourse='',
                        psb_mntrestant='',
                        psb_statut='',
                        pba_brd_code='',
                        pba_cou_code='',
                        pba_psh_ticket_id='',
                        pba_line_nb='',
                        pba_gift_card_serial_num='',
                        pba_flag_activation_conso='',
                        pba_det_modpmt='',
                        pba_qty_sold='',
                        pba_val_faciale='',
                        pba_invoiced_voucher='',
                        pba_mt_presta='',
                        pba_mt_com_act_kdo_ht='',
                        pba_mt_com_act_kdo_ttc='',
                        pba_mt_com_act_kdo_tva='',
                        pss_brd_code='',
                        pss_cou_code='',
                        pss_psh_ticket_id='',
                        pss_line_nb='',
                        pss_typc_sale='',
                        pss_compo_code='',
                        pss_qty='',
                        psc_brd_code='',
                        psc_cou_code='',
                        psc_psh_ticket_id='',
                        psc_csid='',
                        psc_journaissance='',
                        psc_moisnaissance='',
                        psc_anneenaissance='',
                        psc_segment='',
                        psc_typecliente='',
                        version_number='22',
                        source_file_name='FID_LYR_LYR_YRFR_R_VTE_20190515154804.txt',
                        processing_time='2019-05-13 15:31:20.955000')

        # on teste si le retour dans le login comporte bien un message d'erreur
        with LogCapture() as logs:
            self.dofn.process(row_test, self.schema_dict_).next()
            list_logs = [logrecord.msg for logrecord in logs.records]
            self.assertIn('Format error on column "{}" with bad value "{}" and '
                          'Format error on column "{}"'
                          ' with bad value "{}"'.format('psh_tva_prestation',
                                                        'B', 'psh_voucher_dscnt_rate', 'A',
                                                        ), list_logs)
